import React from 'react';
import { ModalProps } from 'react-bootstrap';
export type PopupProps = ModalProps & {
    header?: string | JSX.Element | React.ReactNode | any;
    footer?: string | JSX.Element | React.ReactNode | any;
    showToggle?: string | JSX.Element | React.ReactNode | any;
};
export default function Popup({ header, footer, children, show, onHide, showToggle, ...props }: PopupProps): JSX.Element;
