"use strict";
const require$$0 = require("react");
const reactBootstrap = require("react-bootstrap");
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var hasRequiredReactJsxRuntime_production_min;
function requireReactJsxRuntime_production_min() {
  if (hasRequiredReactJsxRuntime_production_min)
    return reactJsxRuntime_production_min;
  hasRequiredReactJsxRuntime_production_min = 1;
  var f = require$$0, k = Symbol.for("react.element"), l = Symbol.for("react.fragment"), m = Object.prototype.hasOwnProperty, n = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, p = { key: true, ref: true, __self: true, __source: true };
  function q(c, a, g) {
    var b, d = {}, e = null, h = null;
    void 0 !== g && (e = "" + g);
    void 0 !== a.key && (e = "" + a.key);
    void 0 !== a.ref && (h = a.ref);
    for (b in a)
      m.call(a, b) && !p.hasOwnProperty(b) && (d[b] = a[b]);
    if (c && c.defaultProps)
      for (b in a = c.defaultProps, a)
        void 0 === d[b] && (d[b] = a[b]);
    return { $$typeof: k, type: c, key: e, ref: h, props: d, _owner: n.current };
  }
  reactJsxRuntime_production_min.Fragment = l;
  reactJsxRuntime_production_min.jsx = q;
  reactJsxRuntime_production_min.jsxs = q;
  return reactJsxRuntime_production_min;
}
var reactJsxRuntime_development = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var hasRequiredReactJsxRuntime_development;
function requireReactJsxRuntime_development() {
  if (hasRequiredReactJsxRuntime_development)
    return reactJsxRuntime_development;
  hasRequiredReactJsxRuntime_development = 1;
  if (process.env.NODE_ENV !== "production") {
    (function() {
      var React = require$$0;
      var REACT_ELEMENT_TYPE = Symbol.for("react.element");
      var REACT_PORTAL_TYPE = Symbol.for("react.portal");
      var REACT_FRAGMENT_TYPE = Symbol.for("react.fragment");
      var REACT_STRICT_MODE_TYPE = Symbol.for("react.strict_mode");
      var REACT_PROFILER_TYPE = Symbol.for("react.profiler");
      var REACT_PROVIDER_TYPE = Symbol.for("react.provider");
      var REACT_CONTEXT_TYPE = Symbol.for("react.context");
      var REACT_FORWARD_REF_TYPE = Symbol.for("react.forward_ref");
      var REACT_SUSPENSE_TYPE = Symbol.for("react.suspense");
      var REACT_SUSPENSE_LIST_TYPE = Symbol.for("react.suspense_list");
      var REACT_MEMO_TYPE = Symbol.for("react.memo");
      var REACT_LAZY_TYPE = Symbol.for("react.lazy");
      var REACT_OFFSCREEN_TYPE = Symbol.for("react.offscreen");
      var MAYBE_ITERATOR_SYMBOL = Symbol.iterator;
      var FAUX_ITERATOR_SYMBOL = "@@iterator";
      function getIteratorFn(maybeIterable) {
        if (maybeIterable === null || typeof maybeIterable !== "object") {
          return null;
        }
        var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
        if (typeof maybeIterator === "function") {
          return maybeIterator;
        }
        return null;
      }
      var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      function error(format) {
        {
          {
            for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
              args[_key2 - 1] = arguments[_key2];
            }
            printWarning("error", format, args);
          }
        }
      }
      function printWarning(level, format, args) {
        {
          var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame;
          var stack = ReactDebugCurrentFrame2.getStackAddendum();
          if (stack !== "") {
            format += "%s";
            args = args.concat([stack]);
          }
          var argsWithFormat = args.map(function(item) {
            return String(item);
          });
          argsWithFormat.unshift("Warning: " + format);
          Function.prototype.apply.call(console[level], console, argsWithFormat);
        }
      }
      var enableScopeAPI = false;
      var enableCacheElement = false;
      var enableTransitionTracing = false;
      var enableLegacyHidden = false;
      var enableDebugTracing = false;
      var REACT_MODULE_REFERENCE;
      {
        REACT_MODULE_REFERENCE = Symbol.for("react.module.reference");
      }
      function isValidElementType(type) {
        if (typeof type === "string" || typeof type === "function") {
          return true;
        }
        if (type === REACT_FRAGMENT_TYPE || type === REACT_PROFILER_TYPE || enableDebugTracing || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || enableLegacyHidden || type === REACT_OFFSCREEN_TYPE || enableScopeAPI || enableCacheElement || enableTransitionTracing) {
          return true;
        }
        if (typeof type === "object" && type !== null) {
          if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || // This needs to include all possible module reference object
          // types supported by any Flight configuration anywhere since
          // we don't know which Flight build this will end up being used
          // with.
          type.$$typeof === REACT_MODULE_REFERENCE || type.getModuleId !== void 0) {
            return true;
          }
        }
        return false;
      }
      function getWrappedName(outerType, innerType, wrapperName) {
        var displayName = outerType.displayName;
        if (displayName) {
          return displayName;
        }
        var functionName = innerType.displayName || innerType.name || "";
        return functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName;
      }
      function getContextName(type) {
        return type.displayName || "Context";
      }
      function getComponentNameFromType(type) {
        if (type == null) {
          return null;
        }
        {
          if (typeof type.tag === "number") {
            error("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue.");
          }
        }
        if (typeof type === "function") {
          return type.displayName || type.name || null;
        }
        if (typeof type === "string") {
          return type;
        }
        switch (type) {
          case REACT_FRAGMENT_TYPE:
            return "Fragment";
          case REACT_PORTAL_TYPE:
            return "Portal";
          case REACT_PROFILER_TYPE:
            return "Profiler";
          case REACT_STRICT_MODE_TYPE:
            return "StrictMode";
          case REACT_SUSPENSE_TYPE:
            return "Suspense";
          case REACT_SUSPENSE_LIST_TYPE:
            return "SuspenseList";
        }
        if (typeof type === "object") {
          switch (type.$$typeof) {
            case REACT_CONTEXT_TYPE:
              var context = type;
              return getContextName(context) + ".Consumer";
            case REACT_PROVIDER_TYPE:
              var provider = type;
              return getContextName(provider._context) + ".Provider";
            case REACT_FORWARD_REF_TYPE:
              return getWrappedName(type, type.render, "ForwardRef");
            case REACT_MEMO_TYPE:
              var outerName = type.displayName || null;
              if (outerName !== null) {
                return outerName;
              }
              return getComponentNameFromType(type.type) || "Memo";
            case REACT_LAZY_TYPE: {
              var lazyComponent = type;
              var payload = lazyComponent._payload;
              var init = lazyComponent._init;
              try {
                return getComponentNameFromType(init(payload));
              } catch (x) {
                return null;
              }
            }
          }
        }
        return null;
      }
      var assign = Object.assign;
      var disabledDepth = 0;
      var prevLog;
      var prevInfo;
      var prevWarn;
      var prevError;
      var prevGroup;
      var prevGroupCollapsed;
      var prevGroupEnd;
      function disabledLog() {
      }
      disabledLog.__reactDisabledLog = true;
      function disableLogs() {
        {
          if (disabledDepth === 0) {
            prevLog = console.log;
            prevInfo = console.info;
            prevWarn = console.warn;
            prevError = console.error;
            prevGroup = console.group;
            prevGroupCollapsed = console.groupCollapsed;
            prevGroupEnd = console.groupEnd;
            var props = {
              configurable: true,
              enumerable: true,
              value: disabledLog,
              writable: true
            };
            Object.defineProperties(console, {
              info: props,
              log: props,
              warn: props,
              error: props,
              group: props,
              groupCollapsed: props,
              groupEnd: props
            });
          }
          disabledDepth++;
        }
      }
      function reenableLogs() {
        {
          disabledDepth--;
          if (disabledDepth === 0) {
            var props = {
              configurable: true,
              enumerable: true,
              writable: true
            };
            Object.defineProperties(console, {
              log: assign({}, props, {
                value: prevLog
              }),
              info: assign({}, props, {
                value: prevInfo
              }),
              warn: assign({}, props, {
                value: prevWarn
              }),
              error: assign({}, props, {
                value: prevError
              }),
              group: assign({}, props, {
                value: prevGroup
              }),
              groupCollapsed: assign({}, props, {
                value: prevGroupCollapsed
              }),
              groupEnd: assign({}, props, {
                value: prevGroupEnd
              })
            });
          }
          if (disabledDepth < 0) {
            error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
          }
        }
      }
      var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
      var prefix;
      function describeBuiltInComponentFrame(name, source, ownerFn) {
        {
          if (prefix === void 0) {
            try {
              throw Error();
            } catch (x) {
              var match = x.stack.trim().match(/\n( *(at )?)/);
              prefix = match && match[1] || "";
            }
          }
          return "\n" + prefix + name;
        }
      }
      var reentry = false;
      var componentFrameCache;
      {
        var PossiblyWeakMap = typeof WeakMap === "function" ? WeakMap : Map;
        componentFrameCache = new PossiblyWeakMap();
      }
      function describeNativeComponentFrame(fn, construct) {
        if (!fn || reentry) {
          return "";
        }
        {
          var frame = componentFrameCache.get(fn);
          if (frame !== void 0) {
            return frame;
          }
        }
        var control;
        reentry = true;
        var previousPrepareStackTrace = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var previousDispatcher;
        {
          previousDispatcher = ReactCurrentDispatcher.current;
          ReactCurrentDispatcher.current = null;
          disableLogs();
        }
        try {
          if (construct) {
            var Fake = function() {
              throw Error();
            };
            Object.defineProperty(Fake.prototype, "props", {
              set: function() {
                throw Error();
              }
            });
            if (typeof Reflect === "object" && Reflect.construct) {
              try {
                Reflect.construct(Fake, []);
              } catch (x) {
                control = x;
              }
              Reflect.construct(fn, [], Fake);
            } else {
              try {
                Fake.call();
              } catch (x) {
                control = x;
              }
              fn.call(Fake.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (x) {
              control = x;
            }
            fn();
          }
        } catch (sample) {
          if (sample && control && typeof sample.stack === "string") {
            var sampleLines = sample.stack.split("\n");
            var controlLines = control.stack.split("\n");
            var s = sampleLines.length - 1;
            var c = controlLines.length - 1;
            while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
              c--;
            }
            for (; s >= 1 && c >= 0; s--, c--) {
              if (sampleLines[s] !== controlLines[c]) {
                if (s !== 1 || c !== 1) {
                  do {
                    s--;
                    c--;
                    if (c < 0 || sampleLines[s] !== controlLines[c]) {
                      var _frame = "\n" + sampleLines[s].replace(" at new ", " at ");
                      if (fn.displayName && _frame.includes("<anonymous>")) {
                        _frame = _frame.replace("<anonymous>", fn.displayName);
                      }
                      {
                        if (typeof fn === "function") {
                          componentFrameCache.set(fn, _frame);
                        }
                      }
                      return _frame;
                    }
                  } while (s >= 1 && c >= 0);
                }
                break;
              }
            }
          }
        } finally {
          reentry = false;
          {
            ReactCurrentDispatcher.current = previousDispatcher;
            reenableLogs();
          }
          Error.prepareStackTrace = previousPrepareStackTrace;
        }
        var name = fn ? fn.displayName || fn.name : "";
        var syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
        {
          if (typeof fn === "function") {
            componentFrameCache.set(fn, syntheticFrame);
          }
        }
        return syntheticFrame;
      }
      function describeFunctionComponentFrame(fn, source, ownerFn) {
        {
          return describeNativeComponentFrame(fn, false);
        }
      }
      function shouldConstruct(Component) {
        var prototype = Component.prototype;
        return !!(prototype && prototype.isReactComponent);
      }
      function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
        if (type == null) {
          return "";
        }
        if (typeof type === "function") {
          {
            return describeNativeComponentFrame(type, shouldConstruct(type));
          }
        }
        if (typeof type === "string") {
          return describeBuiltInComponentFrame(type);
        }
        switch (type) {
          case REACT_SUSPENSE_TYPE:
            return describeBuiltInComponentFrame("Suspense");
          case REACT_SUSPENSE_LIST_TYPE:
            return describeBuiltInComponentFrame("SuspenseList");
        }
        if (typeof type === "object") {
          switch (type.$$typeof) {
            case REACT_FORWARD_REF_TYPE:
              return describeFunctionComponentFrame(type.render);
            case REACT_MEMO_TYPE:
              return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
            case REACT_LAZY_TYPE: {
              var lazyComponent = type;
              var payload = lazyComponent._payload;
              var init = lazyComponent._init;
              try {
                return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
              } catch (x) {
              }
            }
          }
        }
        return "";
      }
      var hasOwnProperty = Object.prototype.hasOwnProperty;
      var loggedTypeFailures = {};
      var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
      function setCurrentlyValidatingElement(element) {
        {
          if (element) {
            var owner = element._owner;
            var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
            ReactDebugCurrentFrame.setExtraStackFrame(stack);
          } else {
            ReactDebugCurrentFrame.setExtraStackFrame(null);
          }
        }
      }
      function checkPropTypes(typeSpecs, values, location, componentName, element) {
        {
          var has = Function.call.bind(hasOwnProperty);
          for (var typeSpecName in typeSpecs) {
            if (has(typeSpecs, typeSpecName)) {
              var error$1 = void 0;
              try {
                if (typeof typeSpecs[typeSpecName] !== "function") {
                  var err = Error((componentName || "React class") + ": " + location + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  err.name = "Invariant Violation";
                  throw err;
                }
                error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (ex) {
                error$1 = ex;
              }
              if (error$1 && !(error$1 instanceof Error)) {
                setCurrentlyValidatingElement(element);
                error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location, typeSpecName, typeof error$1);
                setCurrentlyValidatingElement(null);
              }
              if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
                loggedTypeFailures[error$1.message] = true;
                setCurrentlyValidatingElement(element);
                error("Failed %s type: %s", location, error$1.message);
                setCurrentlyValidatingElement(null);
              }
            }
          }
        }
      }
      var isArrayImpl = Array.isArray;
      function isArray(a) {
        return isArrayImpl(a);
      }
      function typeName(value) {
        {
          var hasToStringTag = typeof Symbol === "function" && Symbol.toStringTag;
          var type = hasToStringTag && value[Symbol.toStringTag] || value.constructor.name || "Object";
          return type;
        }
      }
      function willCoercionThrow(value) {
        {
          try {
            testStringCoercion(value);
            return false;
          } catch (e) {
            return true;
          }
        }
      }
      function testStringCoercion(value) {
        return "" + value;
      }
      function checkKeyStringCoercion(value) {
        {
          if (willCoercionThrow(value)) {
            error("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value));
            return testStringCoercion(value);
          }
        }
      }
      var ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
      var RESERVED_PROPS = {
        key: true,
        ref: true,
        __self: true,
        __source: true
      };
      var specialPropKeyWarningShown;
      var specialPropRefWarningShown;
      var didWarnAboutStringRefs;
      {
        didWarnAboutStringRefs = {};
      }
      function hasValidRef(config) {
        {
          if (hasOwnProperty.call(config, "ref")) {
            var getter = Object.getOwnPropertyDescriptor(config, "ref").get;
            if (getter && getter.isReactWarning) {
              return false;
            }
          }
        }
        return config.ref !== void 0;
      }
      function hasValidKey(config) {
        {
          if (hasOwnProperty.call(config, "key")) {
            var getter = Object.getOwnPropertyDescriptor(config, "key").get;
            if (getter && getter.isReactWarning) {
              return false;
            }
          }
        }
        return config.key !== void 0;
      }
      function warnIfStringRefCannotBeAutoConverted(config, self) {
        {
          if (typeof config.ref === "string" && ReactCurrentOwner.current && self && ReactCurrentOwner.current.stateNode !== self) {
            var componentName = getComponentNameFromType(ReactCurrentOwner.current.type);
            if (!didWarnAboutStringRefs[componentName]) {
              error('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', getComponentNameFromType(ReactCurrentOwner.current.type), config.ref);
              didWarnAboutStringRefs[componentName] = true;
            }
          }
        }
      }
      function defineKeyPropWarningGetter(props, displayName) {
        {
          var warnAboutAccessingKey = function() {
            if (!specialPropKeyWarningShown) {
              specialPropKeyWarningShown = true;
              error("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName);
            }
          };
          warnAboutAccessingKey.isReactWarning = true;
          Object.defineProperty(props, "key", {
            get: warnAboutAccessingKey,
            configurable: true
          });
        }
      }
      function defineRefPropWarningGetter(props, displayName) {
        {
          var warnAboutAccessingRef = function() {
            if (!specialPropRefWarningShown) {
              specialPropRefWarningShown = true;
              error("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName);
            }
          };
          warnAboutAccessingRef.isReactWarning = true;
          Object.defineProperty(props, "ref", {
            get: warnAboutAccessingRef,
            configurable: true
          });
        }
      }
      var ReactElement = function(type, key, ref, self, source, owner, props) {
        var element = {
          // This tag allows us to uniquely identify this as a React Element
          $$typeof: REACT_ELEMENT_TYPE,
          // Built-in properties that belong on the element
          type,
          key,
          ref,
          props,
          // Record the component responsible for creating this element.
          _owner: owner
        };
        {
          element._store = {};
          Object.defineProperty(element._store, "validated", {
            configurable: false,
            enumerable: false,
            writable: true,
            value: false
          });
          Object.defineProperty(element, "_self", {
            configurable: false,
            enumerable: false,
            writable: false,
            value: self
          });
          Object.defineProperty(element, "_source", {
            configurable: false,
            enumerable: false,
            writable: false,
            value: source
          });
          if (Object.freeze) {
            Object.freeze(element.props);
            Object.freeze(element);
          }
        }
        return element;
      };
      function jsxDEV(type, config, maybeKey, source, self) {
        {
          var propName;
          var props = {};
          var key = null;
          var ref = null;
          if (maybeKey !== void 0) {
            {
              checkKeyStringCoercion(maybeKey);
            }
            key = "" + maybeKey;
          }
          if (hasValidKey(config)) {
            {
              checkKeyStringCoercion(config.key);
            }
            key = "" + config.key;
          }
          if (hasValidRef(config)) {
            ref = config.ref;
            warnIfStringRefCannotBeAutoConverted(config, self);
          }
          for (propName in config) {
            if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
              props[propName] = config[propName];
            }
          }
          if (type && type.defaultProps) {
            var defaultProps = type.defaultProps;
            for (propName in defaultProps) {
              if (props[propName] === void 0) {
                props[propName] = defaultProps[propName];
              }
            }
          }
          if (key || ref) {
            var displayName = typeof type === "function" ? type.displayName || type.name || "Unknown" : type;
            if (key) {
              defineKeyPropWarningGetter(props, displayName);
            }
            if (ref) {
              defineRefPropWarningGetter(props, displayName);
            }
          }
          return ReactElement(type, key, ref, self, source, ReactCurrentOwner.current, props);
        }
      }
      var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner;
      var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;
      function setCurrentlyValidatingElement$1(element) {
        {
          if (element) {
            var owner = element._owner;
            var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
            ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
          } else {
            ReactDebugCurrentFrame$1.setExtraStackFrame(null);
          }
        }
      }
      var propTypesMisspellWarningShown;
      {
        propTypesMisspellWarningShown = false;
      }
      function isValidElement(object) {
        {
          return typeof object === "object" && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
        }
      }
      function getDeclarationErrorAddendum() {
        {
          if (ReactCurrentOwner$1.current) {
            var name = getComponentNameFromType(ReactCurrentOwner$1.current.type);
            if (name) {
              return "\n\nCheck the render method of `" + name + "`.";
            }
          }
          return "";
        }
      }
      function getSourceInfoErrorAddendum(source) {
        {
          if (source !== void 0) {
            var fileName = source.fileName.replace(/^.*[\\\/]/, "");
            var lineNumber = source.lineNumber;
            return "\n\nCheck your code at " + fileName + ":" + lineNumber + ".";
          }
          return "";
        }
      }
      var ownerHasKeyUseWarning = {};
      function getCurrentComponentErrorInfo(parentType) {
        {
          var info = getDeclarationErrorAddendum();
          if (!info) {
            var parentName = typeof parentType === "string" ? parentType : parentType.displayName || parentType.name;
            if (parentName) {
              info = "\n\nCheck the top-level render call using <" + parentName + ">.";
            }
          }
          return info;
        }
      }
      function validateExplicitKey(element, parentType) {
        {
          if (!element._store || element._store.validated || element.key != null) {
            return;
          }
          element._store.validated = true;
          var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);
          if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
            return;
          }
          ownerHasKeyUseWarning[currentComponentErrorInfo] = true;
          var childOwner = "";
          if (element && element._owner && element._owner !== ReactCurrentOwner$1.current) {
            childOwner = " It was passed a child from " + getComponentNameFromType(element._owner.type) + ".";
          }
          setCurrentlyValidatingElement$1(element);
          error('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', currentComponentErrorInfo, childOwner);
          setCurrentlyValidatingElement$1(null);
        }
      }
      function validateChildKeys(node, parentType) {
        {
          if (typeof node !== "object") {
            return;
          }
          if (isArray(node)) {
            for (var i = 0; i < node.length; i++) {
              var child = node[i];
              if (isValidElement(child)) {
                validateExplicitKey(child, parentType);
              }
            }
          } else if (isValidElement(node)) {
            if (node._store) {
              node._store.validated = true;
            }
          } else if (node) {
            var iteratorFn = getIteratorFn(node);
            if (typeof iteratorFn === "function") {
              if (iteratorFn !== node.entries) {
                var iterator = iteratorFn.call(node);
                var step;
                while (!(step = iterator.next()).done) {
                  if (isValidElement(step.value)) {
                    validateExplicitKey(step.value, parentType);
                  }
                }
              }
            }
          }
        }
      }
      function validatePropTypes(element) {
        {
          var type = element.type;
          if (type === null || type === void 0 || typeof type === "string") {
            return;
          }
          var propTypes;
          if (typeof type === "function") {
            propTypes = type.propTypes;
          } else if (typeof type === "object" && (type.$$typeof === REACT_FORWARD_REF_TYPE || // Note: Memo only checks outer props here.
          // Inner props are checked in the reconciler.
          type.$$typeof === REACT_MEMO_TYPE)) {
            propTypes = type.propTypes;
          } else {
            return;
          }
          if (propTypes) {
            var name = getComponentNameFromType(type);
            checkPropTypes(propTypes, element.props, "prop", name, element);
          } else if (type.PropTypes !== void 0 && !propTypesMisspellWarningShown) {
            propTypesMisspellWarningShown = true;
            var _name = getComponentNameFromType(type);
            error("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", _name || "Unknown");
          }
          if (typeof type.getDefaultProps === "function" && !type.getDefaultProps.isReactClassApproved) {
            error("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
          }
        }
      }
      function validateFragmentProps(fragment) {
        {
          var keys = Object.keys(fragment.props);
          for (var i = 0; i < keys.length; i++) {
            var key = keys[i];
            if (key !== "children" && key !== "key") {
              setCurrentlyValidatingElement$1(fragment);
              error("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", key);
              setCurrentlyValidatingElement$1(null);
              break;
            }
          }
          if (fragment.ref !== null) {
            setCurrentlyValidatingElement$1(fragment);
            error("Invalid attribute `ref` supplied to `React.Fragment`.");
            setCurrentlyValidatingElement$1(null);
          }
        }
      }
      var didWarnAboutKeySpread = {};
      function jsxWithValidation(type, props, key, isStaticChildren, source, self) {
        {
          var validType = isValidElementType(type);
          if (!validType) {
            var info = "";
            if (type === void 0 || typeof type === "object" && type !== null && Object.keys(type).length === 0) {
              info += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.";
            }
            var sourceInfo = getSourceInfoErrorAddendum(source);
            if (sourceInfo) {
              info += sourceInfo;
            } else {
              info += getDeclarationErrorAddendum();
            }
            var typeString;
            if (type === null) {
              typeString = "null";
            } else if (isArray(type)) {
              typeString = "array";
            } else if (type !== void 0 && type.$$typeof === REACT_ELEMENT_TYPE) {
              typeString = "<" + (getComponentNameFromType(type.type) || "Unknown") + " />";
              info = " Did you accidentally export a JSX literal instead of a component?";
            } else {
              typeString = typeof type;
            }
            error("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", typeString, info);
          }
          var element = jsxDEV(type, props, key, source, self);
          if (element == null) {
            return element;
          }
          if (validType) {
            var children = props.children;
            if (children !== void 0) {
              if (isStaticChildren) {
                if (isArray(children)) {
                  for (var i = 0; i < children.length; i++) {
                    validateChildKeys(children[i], type);
                  }
                  if (Object.freeze) {
                    Object.freeze(children);
                  }
                } else {
                  error("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
                }
              } else {
                validateChildKeys(children, type);
              }
            }
          }
          {
            if (hasOwnProperty.call(props, "key")) {
              var componentName = getComponentNameFromType(type);
              var keys = Object.keys(props).filter(function(k) {
                return k !== "key";
              });
              var beforeExample = keys.length > 0 ? "{key: someKey, " + keys.join(": ..., ") + ": ...}" : "{key: someKey}";
              if (!didWarnAboutKeySpread[componentName + beforeExample]) {
                var afterExample = keys.length > 0 ? "{" + keys.join(": ..., ") + ": ...}" : "{}";
                error('A props object containing a "key" prop is being spread into JSX:\n  let props = %s;\n  <%s {...props} />\nReact keys must be passed directly to JSX without using spread:\n  let props = %s;\n  <%s key={someKey} {...props} />', beforeExample, componentName, afterExample, componentName);
                didWarnAboutKeySpread[componentName + beforeExample] = true;
              }
            }
          }
          if (type === REACT_FRAGMENT_TYPE) {
            validateFragmentProps(element);
          } else {
            validatePropTypes(element);
          }
          return element;
        }
      }
      function jsxWithValidationStatic(type, props, key) {
        {
          return jsxWithValidation(type, props, key, true);
        }
      }
      function jsxWithValidationDynamic(type, props, key) {
        {
          return jsxWithValidation(type, props, key, false);
        }
      }
      var jsx = jsxWithValidationDynamic;
      var jsxs = jsxWithValidationStatic;
      reactJsxRuntime_development.Fragment = REACT_FRAGMENT_TYPE;
      reactJsxRuntime_development.jsx = jsx;
      reactJsxRuntime_development.jsxs = jsxs;
    })();
  }
  return reactJsxRuntime_development;
}
if (process.env.NODE_ENV === "production") {
  jsxRuntime.exports = requireReactJsxRuntime_production_min();
} else {
  jsxRuntime.exports = requireReactJsxRuntime_development();
}
var jsxRuntimeExports = jsxRuntime.exports;
function AlertBox({ children, Header, close, timeout, ...props }) {
  const [Show, setShow] = require$$0.useState(true);
  require$$0.useEffect(() => {
    if (!close || !timeout)
      return;
    setTimeout(changeShow, timeout);
  }, [close, timeout]);
  function changeShow() {
    setShow(!Show);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Alert, { ...props, dismissible: close, show: Show, onClose: changeShow, children: /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Row, { children: /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Col, { xs: true, children: [
    Header && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Alert.Heading, { children: Header }),
    children
  ] }) }) });
}
function Anchor(props) {
  return /* @__PURE__ */ jsxRuntimeExports.jsx(
    "a",
    {
      ...props,
      className: (props.as === "button" ? `btn btn-${props.variant || "primary"} ` : "") + (props.className || "")
    }
  );
}
function Paginate(props) {
  function toPrev() {
    props.setPage(Math.max(props.meta.currentPage - 1, 1));
  }
  function toNext() {
    props.setPage(Math.min(props.meta.lastPage, props.meta.currentPage + 1));
  }
  function toFirst() {
    props.setPage(1);
  }
  function toLast() {
    props.setPage(props.meta.lastPage);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Pagination, { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.First, { onClick: toFirst, disabled: props.meta.currentPage === 1 }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Prev, { onClick: toPrev, disabled: props.meta.currentPage === 1 }),
    props.meta.currentPage !== 1 && /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
      props.meta.currentPage - 1 !== 1 && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Ellipsis, {}),
      /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Item, { onClick: toPrev, children: props.meta.currentPage - 1 })
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Item, { active: true, children: props.meta.currentPage }),
    props.meta.currentPage !== props.meta.lastPage && /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
      /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Item, { onClick: toNext, children: props.meta.currentPage + 1 }),
      /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Ellipsis, {})
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Next, { onClick: toNext, disabled: props.meta.lastPage === props.meta.currentPage }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Pagination.Last, { onClick: toLast, disabled: props.meta.currentPage === props.meta.lastPage })
  ] });
}
const FormContext = require$$0.createContext({
  getError: () => void 0,
  changeError: () => {
  }
});
function useForm() {
  const [ErrorR, setError] = require$$0.useState();
  function getError(key = void 0) {
    if (key === void 0)
      return ErrorR;
    if (ErrorR === void 0)
      return ErrorR;
    if (ErrorR[key])
      return ErrorR[key];
    return void 0;
  }
  function changeError(error = void 0) {
    setError(error === void 0 ? void 0 : { ...{}, ...error });
  }
  return {
    Error: ErrorR,
    getError,
    changeError
  };
}
function FormWrapper(props) {
  const [Validated, setValidated] = require$$0.useState(false);
  const [ButtonDisabled, setButtonDisabled] = require$$0.useState(false);
  const [Success, setSuccess] = require$$0.useState(false);
  const Error2 = useForm();
  require$$0.useEffect(() => {
    if (props.setButtonDisabled)
      props.setButtonDisabled(ButtonDisabled);
  }, [ButtonDisabled]);
  async function onSubmit(e) {
    e.preventDefault();
    setButtonDisabled(true);
    Error2.changeError(void 0);
    if (!e.currentTarget.checkValidity()) {
      setValidated(true);
      setButtonDisabled(false);
      return;
    }
    setValidated(false);
    const response = await props.onSubmit(e);
    if (response.error) {
      Error2.changeError(response.error);
      setValidated(true);
    }
    if (!response.error) {
      setSuccess(true);
      setTimeout(() => {
        setSuccess(false);
      }, props.successMessageTimeout || 5e3);
    }
    if (response.payloads && props.success)
      props.success(response.payloads);
    setButtonDisabled(false);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(FormContext.Provider, { value: Error2, children: /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Form, { noValidate: true, validated: Validated, onSubmit, children: [
    Error2.getError() && /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Alert, { variant: "warning", children: [
      /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Alert.Heading, { children: [
        Error2.getError("abstract") && /* @__PURE__ */ jsxRuntimeExports.jsxs("span", { children: [
          "[",
          Error2.getError("abstract"),
          "]"
        ] }),
        Error2.getError("title") && /* @__PURE__ */ jsxRuntimeExports.jsx("span", { children: Error2.getError("title") })
      ] }),
      Error2.getError("messages") && props.ErrorMessages ? /* @__PURE__ */ jsxRuntimeExports.jsx(props.ErrorMessages, { messages: Error2.getError("messages") }) : /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: Error2.getError("messages"), ignoreObject: true })
    ] }),
    Success && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Alert, { variant: "success", children: props.successMessage || "処理に成功しました" }),
    props.children
  ] }) });
}
function ErrorMessages(props) {
  if (props.messages === void 0)
    return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, {});
  if (Array.isArray(props.messages))
    return /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { children: props.messages.map(
      (message, idx) => /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: message }, `errorMessageArray-${idx}`)
    ) });
  if (typeof props.messages === "string" || props.messages instanceof String)
    return /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: props.messages });
  if (props.messages !== null && typeof props.messages === "object") {
    if (props.ignoreObject)
      return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, {});
    return /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { className: "mb-0", children: Object.keys(props.messages).map(
      (key, idx) => /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: props.messages[key] }, `errorMessageObject-${idx}`)
    ) });
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, {});
}
function Input({
  validMessage,
  invalidMessage,
  beforeText,
  afterText,
  value,
  defaultValue,
  onChange,
  countShow = true,
  autoResize = true,
  ...props
}) {
  var _a, _b;
  const [Messages, setMessages] = require$$0.useState();
  const [Count, setCount] = require$$0.useState(((value == null ? void 0 : value.toString()) || (defaultValue == null ? void 0 : defaultValue.toString()) || "").length);
  const formContext = require$$0.useContext(FormContext);
  const IdRef = require$$0.useRef(props.id || createKey());
  require$$0.useEffect(() => {
    const element = document.getElementById(IdRef.current);
    if (!element || ["INPUT", "TEXTAREA"].indexOf(element.tagName) === -1)
      return;
    resizeHeight(element);
  }, []);
  require$$0.useEffect(() => {
    const messages = formContext.getError("messages");
    if (messages === void 0) {
      setMessages(void 0);
      return;
    }
    if (props.name && messages[props.name]) {
      setMessages({ ...{}, ...messages[props.name] });
    } else {
      setMessages(void 0);
    }
  }, [formContext.getError("messages")]);
  function handleChange(e) {
    resizeHeight(e.currentTarget);
    setCount(e.currentTarget.value.length);
    if (onChange)
      onChange(e);
  }
  function resizeHeight(element) {
    if (props.as !== "textarea" || !autoResize)
      return;
    element.style.minHeight = `100px`;
    element.style.height = `${element.scrollHeight - 100}px`;
    element.style.height = `${element.scrollHeight + 2}px`;
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsxs(InputGroupWrapper, { beforeText, afterText, children: [
      /* @__PURE__ */ jsxRuntimeExports.jsx(
        reactBootstrap.Form.Control,
        {
          ...props,
          value: value || void 0,
          defaultValue: defaultValue || void 0,
          id: IdRef.current,
          placeholder: props.placeholder,
          isInvalid: props.isInvalid || (Messages ? true : false),
          className: (props.className || "") + (props.isInvalid || (Messages ? true : false) ? " border-danger" : ""),
          onChange: handleChange
        }
      ),
      validMessage && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Form.Control.Feedback, { className: "ms-2", children: /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { children: validMessage.map(
        (mes) => /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: mes }, mes)
      ) }) }),
      (invalidMessage || ((_a = formContext.Error) == null ? void 0 : _a.messages) && props.name && !Array.isArray(formContext.Error.messages) && formContext.Error.messages[props.name]) && /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Form.Control.Feedback, { type: "invalid", className: "ms-2 mb-2", children: [
        invalidMessage && /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { className: "mb-0", children: invalidMessage.map(
          (mes) => /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: mes }, mes)
        ) }),
        ((_b = formContext.Error) == null ? void 0 : _b.messages) && props.name && !Array.isArray(formContext.Error.messages) && formContext.Error.messages[props.name] && /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: formContext.Error.messages[props.name] })
      ] })
    ] }),
    countShow && whichShowCount(props.type) && /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Form.Text, { className: "d-block text-end", children: [
      Count,
      props.maxLength && `/${props.maxLength}`,
      "words"
    ] })
  ] });
}
function whichShowCount(type = void 0) {
  switch (type) {
    case "date":
    case "datetime":
    case "datetime-local":
    case "time":
      return false;
    default:
      return true;
  }
}
function InputGroupWrapper(props) {
  if (!props.beforeText && !props.afterText)
    return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, { children: props.children });
  return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, { children: /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.InputGroup, { children: [
    props.beforeText && (Array.isArray(props.beforeText) ? props.beforeText.map((node) => /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.InputGroup.Text, { children: node })) : /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.InputGroup.Text, { children: props.beforeText })),
    props.children,
    props.afterText && (Array.isArray(props.afterText) ? props.afterText.map((node) => /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.InputGroup.Text, { children: node })) : /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.InputGroup.Text, { children: props.afterText }))
  ] }) });
}
function InputWrapper(props) {
  const formContext = require$$0.useContext(FormContext);
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "mb-2 " + props.className, children: [
    /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Form.Label, { className: "mb-1", children: [
      props.label,
      props.required && /* @__PURE__ */ jsxRuntimeExports.jsx("span", { className: "text-danger", children: "＊" })
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Form.Text, { className: "mb-2 ps-2 d-block", children: props.description }),
    props.children,
    props.feedbackMessage && props.name && formContext.getError("messages") && formContext.getError("messages")[props.name] && /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "text-danger ms-1", children: /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: formContext.getError("messages")[props.name] }) })
  ] });
}
function Control({ label, wrapperClassName, description, ...props }) {
  return /* @__PURE__ */ jsxRuntimeExports.jsx(
    InputWrapper,
    {
      label,
      required: props.required,
      name: props.name,
      feedbackMessage: false,
      className: wrapperClassName,
      description,
      children: /* @__PURE__ */ jsxRuntimeExports.jsx(Input, { ...props, placeholder: props.placeholder || label })
    }
  );
}
const FilterInit = { per: 10, order: "asc", keyword: "" };
function ListView(props) {
  const [Page, setPage] = require$$0.useState(1);
  const [Payloads, setPayloads] = require$$0.useState();
  const [Filter, setFilter] = require$$0.useState({
    ...{},
    ...props.filter || { ...{}, ...FilterInit }
  });
  const WrapperRef = require$$0.useRef(null);
  require$$0.useEffect(() => {
    getItems();
  }, [Page, props.reload, Filter]);
  async function getItems() {
    const payloads = await props.getItems({ page: Page, ...Filter });
    if (!payloads)
      return;
    setPayloads({ ...{}, ...payloads });
    if (WrapperRef.current && props.moveToList)
      window.scroll({ top: WrapperRef.current.getBoundingClientRect().top + window.pageYOffset });
  }
  if (!Payloads)
    return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, {});
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "mb-2", ref: WrapperRef, children: /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Row, { className: "justify-content-between", children: [
      /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Col, { xs: "auto", sm: "auto", className: "mt-2", children: [
        Payloads.meta.length,
        "件中",
        Payloads.meta.getLength,
        "件表示中",
        /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "text-muted", style: { fontSize: ".75em" }, children: [
          "検索条件：",
          (props.ConvertFilter ? props.ConvertFilter(Filter) : ConvertFilter(Filter)).join(",")
        ] })
      ] }),
      /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Col, { xs: "auto", sm: "auto", className: "mt-2", children: /* @__PURE__ */ jsxRuntimeExports.jsx(FilterElement, { Filter: Filter || {}, setFilter, ...props.FilterProps }) })
    ] }) }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(props.itemWrapper, { children: Payloads.items.map(props.itemCallback) }),
    /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "mt-2", children: /* @__PURE__ */ jsxRuntimeExports.jsx(Paginate, { meta: Payloads.meta, setPage }) })
  ] });
}
function ConvertFilter(Filter, key_JP = {
  per: "取得件数",
  keyword: "キーワード",
  order: "表示順序"
}, key_res = {
  per: "$$件",
  keyword: "$$",
  order: {
    asc: "昇順",
    desc: "降順"
  }
}) {
  const filters = [];
  Object.keys(Filter).forEach((key) => {
    const key_filter = key;
    if (!Filter[key_filter])
      return;
    if (!key_JP[key] || !key_res[key])
      return;
    let res = `${key_JP[key]}`;
    if (key_res[key][Filter[key_filter]]) {
      res += `（${key_res[key][Filter[key_filter]]}）`;
    } else {
      res += `（${key_res[key].replace("$$", Filter[key_filter])}）`;
    }
    filters.push(res);
  });
  return filters;
}
function FilterElement(props) {
  const [FilterShow, setFilterShow] = require$$0.useState(false);
  const [Filter, setFilter] = require$$0.useState({ ...{}, ...props.Filter });
  const [FilterCan, setFilterCan] = require$$0.useState([]);
  require$$0.useEffect(() => {
    let only = props.only || Object.keys(FilterInit);
    only = only.filter((value) => {
      return (props.except || []).indexOf(value) === -1;
    });
    setFilterCan(only.concat([]));
  }, []);
  function changeFilterShow() {
    setFilterShow(!FilterShow);
  }
  function onChangeFilterStr(e) {
    const key = e.currentTarget.name;
    if (e.currentTarget.value === "") {
      if (Filter[key])
        delete Filter[key];
    } else {
      Filter[key] = e.currentTarget.value;
    }
    setFilter({ ...{}, ...Filter });
  }
  function onChangeFilterNum(e) {
    const key = e.currentTarget.name;
    if (e.currentTarget.value === "") {
      if (Filter[key])
        delete Filter[key];
    } else {
      Filter[key] = Number(e.currentTarget.value);
    }
    setFilter({ ...{}, ...Filter });
  }
  function onClickUpdate() {
    changeFilterShow();
    props.setFilter({ ...{}, ...Filter });
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(
    reactBootstrap.OverlayTrigger,
    {
      trigger: ["click"],
      placement: "bottom-end",
      show: FilterShow,
      onToggle: changeFilterShow,
      overlay: /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Popover, { id: "listview-filter", children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Popover.Header, { children: "絞り込み" }),
        /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Popover.Body, { className: "w-100", children: [
          /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Row, { children: [
            FilterCan.indexOf("per") > -1 && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Col, { sm: "auto", className: "mt-1", children: /* @__PURE__ */ jsxRuntimeExports.jsx(InputWrapper, { label: "表示件数", children: /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Form.Select, { name: "per", value: Filter["per"] || 10, onChange: onChangeFilterNum, children: [
              /* @__PURE__ */ jsxRuntimeExports.jsx("option", { value: "10", children: "10" }),
              /* @__PURE__ */ jsxRuntimeExports.jsx("option", { value: "50", children: "50" }),
              /* @__PURE__ */ jsxRuntimeExports.jsx("option", { value: "100", children: "100" })
            ] }) }) }),
            FilterCan.indexOf("order") > -1 && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Col, { sm: "auto", className: "mt-1", children: /* @__PURE__ */ jsxRuntimeExports.jsx(InputWrapper, { label: "表示順序", children: /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Form.Select, { name: "order", value: Filter["order"] || "asc", onChange: onChangeFilterStr, children: [
              /* @__PURE__ */ jsxRuntimeExports.jsx("option", { value: "asc", children: "昇順" }),
              /* @__PURE__ */ jsxRuntimeExports.jsx("option", { value: "desc", children: "降順" })
            ] }) }) }),
            FilterCan.indexOf("keyword") > -1 && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Col, { sm: "auto", className: "mt-1", children: /* @__PURE__ */ jsxRuntimeExports.jsx(
              Control,
              {
                label: "キーワード",
                type: "search",
                name: "keyword",
                value: Filter["keyword"] || "",
                onChange: onChangeFilterStr,
                countShow: false
              }
            ) })
          ] }),
          props.children,
          /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Row, { className: "justify-content-end mt-2", children: /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Col, { sm: "auto", className: "mt-1", children: /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Button, { variant: "primary", type: "button", onClick: onClickUpdate, children: "絞り込み" }) }) })
        ] })
      ] }),
      children: /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Button, { variant: FilterShow ? "secondary" : "outline-secondary", type: "button", children: "絞り込み" })
    }
  );
}
function PageWrapper({
  title,
  breadCrumb,
  breadCrumbOnClick,
  homeText,
  onAnchorClick,
  changeLink,
  changeTitle,
  siteTitle,
  titleSeparator,
  children,
  ...props
}) {
  require$$0.useEffect(() => {
    let titles = [];
    if (title)
      titles.push(title);
    if (siteTitle)
      titles.push(siteTitle);
    document.title = titles.join(` ${titleSeparator || "-"} `);
  }, [title]);
  function homeOnClick(e) {
    if (changeLink) {
      e.preventDefault();
      return changeLink("/");
    }
    if (onAnchorClick)
      return onAnchorClick(e);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { ...props, children: [
      /* @__PURE__ */ jsxRuntimeExports.jsx("h3", { children: title }),
      breadCrumb && /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Breadcrumb, { className: "my-2", children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Breadcrumb.Item, { href: "/", onClick: homeOnClick, children: homeText || "HOME" }),
        breadCrumb.map(
          (item) => /* @__PURE__ */ jsxRuntimeExports.jsx(
            BreadcrumbItem,
            {
              item,
              navigate: breadCrumbOnClick,
              onAnchorClick,
              changeLink
            },
            item.text
          )
        ),
        /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Breadcrumb.Item, { active: true, children: title })
      ] })
    ] }),
    children
  ] });
}
function BreadcrumbItem(props) {
  function onClick(e) {
    if (props.navigate)
      return props.navigate(e, props.item);
    if (props.changeLink) {
      e.preventDefault();
      return props.changeLink(props.item.link);
    }
    if (props.onAnchorClick)
      return props.onAnchorClick(e);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Breadcrumb.Item, { href: props.item.link, onClick, children: props.item.text });
}
function Popup({
  header,
  footer,
  children,
  show,
  onHide,
  showToggle,
  ...props
}) {
  const [Show, setShow] = require$$0.useState(false);
  require$$0.useEffect(() => {
    if (show !== void 0)
      setShow(show);
  }, [show]);
  function changeShow() {
    setShow(!Show);
    if (onHide)
      onHide();
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
    showToggle && /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "d-inline-block", onClick: changeShow, children: showToggle }),
    /* @__PURE__ */ jsxRuntimeExports.jsxs(reactBootstrap.Modal, { animation: true, scrollable: true, centered: true, ...props, show: Show, onHide: changeShow, children: [
      header && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Modal.Header, { closeButton: true, children: header }),
      /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Modal.Body, { children }),
      footer && /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Modal.Footer, { children: footer })
    ] })
  ] });
}
const StatusContext = require$$0.createContext({
  Flush: { body: "" },
  getFlush: () => null,
  changeFlush: () => {
  },
  removeFlush: () => {
  }
});
function useStatus() {
  const [Flush, setFlush] = require$$0.useState(null);
  function getFlush() {
    return Flush;
  }
  function changeFlush(status = null) {
    setFlush(status === null ? null : { ...{}, ...status });
  }
  function removeFlush() {
    setFlush(null);
  }
  return {
    Flush,
    getFlush,
    changeFlush,
    removeFlush
  };
}
function StatusWrapper(props) {
  const Status2 = useStatus();
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(StatusContext.Provider, { value: Status2, children: [
    props.children,
    JSON.stringify(Status2)
  ] });
}
function StatusView(props) {
  var _a, _b;
  const Status2 = require$$0.useContext(StatusContext);
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { children: [
    (_a = Status2.getFlush()) == null ? void 0 : _a.title,
    (_b = Status2.getFlush()) == null ? void 0 : _b.body,
    props.children
  ] });
}
const Status = Object.assign({}, StatusView, {
  Wrapper: StatusWrapper,
  View: StatusView
});
const style = "";
function Table({ fixedTitle, wrapperHeight, ...props }) {
  if (!fixedTitle)
    return /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Table, { ...props });
  const WrapperStyle = {
    height: wrapperHeight
  };
  return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, { children: /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "all-on-screen", style: WrapperStyle, children: /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "fixed-table__wrapper", children: /* @__PURE__ */ jsxRuntimeExports.jsx(reactBootstrap.Table, { ...props, className: `${props.className || ""} fixed-table` }) }) }) });
}
function createKey() {
  return Math.random().toString(32).substring(2);
}
exports.AlertBox = AlertBox;
exports.Anchor = Anchor;
exports.Control = Control;
exports.ErrorMessages = ErrorMessages;
exports.FormContext = FormContext;
exports.FormWrapper = FormWrapper;
exports.Input = Input;
exports.InputWrapper = InputWrapper;
exports.ListView = ListView;
exports.PageWrapper = PageWrapper;
exports.Paginate = Paginate;
exports.Popup = Popup;
exports.Status = Status;
exports.StatusContext = StatusContext;
exports.StatusWrapper = StatusWrapper;
exports.Table = Table;
exports.createKey = createKey;
exports.jsxRuntimeExports = jsxRuntimeExports;
exports.useStatus = useStatus;
